# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from adhoc_communication/SendExpAuctionRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import adhoc_communication.msg

class SendExpAuctionRequest(genpy.Message):
  _md5sum = "402f0303dc933f57bece3d13fe58db17"
  _type = "adhoc_communication/SendExpAuctionRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string topic
string dst_robot
adhoc_communication/ExpAuction auction

================================================================================
MSG: adhoc_communication/ExpAuction
bool auction_status_message
bool start_auction
bool auction_finished
ExpAuctionElement[] occupied_ids
ExpCluster[] requested_clusters
uint32 auction_id
string robot_name
ExpCluster[] available_clusters

================================================================================
MSG: adhoc_communication/ExpAuctionElement
int64 id
string detected_by_robot_str

================================================================================
MSG: adhoc_communication/ExpCluster
ExpClusterElement[] ids_contained
float64 bid 

================================================================================
MSG: adhoc_communication/ExpClusterElement
int64 id
string detected_by_robot_str
"""
  __slots__ = ['topic','dst_robot','auction']
  _slot_types = ['string','string','adhoc_communication/ExpAuction']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       topic,dst_robot,auction

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SendExpAuctionRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.topic is None:
        self.topic = ''
      if self.dst_robot is None:
        self.dst_robot = ''
      if self.auction is None:
        self.auction = adhoc_communication.msg.ExpAuction()
    else:
      self.topic = ''
      self.dst_robot = ''
      self.auction = adhoc_communication.msg.ExpAuction()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.topic
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.dst_robot
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3B.pack(_x.auction.auction_status_message, _x.auction.start_auction, _x.auction.auction_finished))
      length = len(self.auction.occupied_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.auction.occupied_ids:
        buff.write(_struct_q.pack(val1.id))
        _x = val1.detected_by_robot_str
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.auction.requested_clusters)
      buff.write(_struct_I.pack(length))
      for val1 in self.auction.requested_clusters:
        length = len(val1.ids_contained)
        buff.write(_struct_I.pack(length))
        for val2 in val1.ids_contained:
          buff.write(_struct_q.pack(val2.id))
          _x = val2.detected_by_robot_str
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.bid))
      buff.write(_struct_I.pack(self.auction.auction_id))
      _x = self.auction.robot_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.auction.available_clusters)
      buff.write(_struct_I.pack(length))
      for val1 in self.auction.available_clusters:
        length = len(val1.ids_contained)
        buff.write(_struct_I.pack(length))
        for val2 in val1.ids_contained:
          buff.write(_struct_q.pack(val2.id))
          _x = val2.detected_by_robot_str
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.bid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.auction is None:
        self.auction = adhoc_communication.msg.ExpAuction()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.topic = str[start:end].decode('utf-8')
      else:
        self.topic = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dst_robot = str[start:end].decode('utf-8')
      else:
        self.dst_robot = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.auction.auction_status_message, _x.auction.start_auction, _x.auction.auction_finished,) = _struct_3B.unpack(str[start:end])
      self.auction.auction_status_message = bool(self.auction.auction_status_message)
      self.auction.start_auction = bool(self.auction.start_auction)
      self.auction.auction_finished = bool(self.auction.auction_finished)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.auction.occupied_ids = []
      for i in range(0, length):
        val1 = adhoc_communication.msg.ExpAuctionElement()
        start = end
        end += 8
        (val1.id,) = _struct_q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.detected_by_robot_str = str[start:end].decode('utf-8')
        else:
          val1.detected_by_robot_str = str[start:end]
        self.auction.occupied_ids.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.auction.requested_clusters = []
      for i in range(0, length):
        val1 = adhoc_communication.msg.ExpCluster()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.ids_contained = []
        for i in range(0, length):
          val2 = adhoc_communication.msg.ExpClusterElement()
          start = end
          end += 8
          (val2.id,) = _struct_q.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detected_by_robot_str = str[start:end].decode('utf-8')
          else:
            val2.detected_by_robot_str = str[start:end]
          val1.ids_contained.append(val2)
        start = end
        end += 8
        (val1.bid,) = _struct_d.unpack(str[start:end])
        self.auction.requested_clusters.append(val1)
      start = end
      end += 4
      (self.auction.auction_id,) = _struct_I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.auction.robot_name = str[start:end].decode('utf-8')
      else:
        self.auction.robot_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.auction.available_clusters = []
      for i in range(0, length):
        val1 = adhoc_communication.msg.ExpCluster()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.ids_contained = []
        for i in range(0, length):
          val2 = adhoc_communication.msg.ExpClusterElement()
          start = end
          end += 8
          (val2.id,) = _struct_q.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detected_by_robot_str = str[start:end].decode('utf-8')
          else:
            val2.detected_by_robot_str = str[start:end]
          val1.ids_contained.append(val2)
        start = end
        end += 8
        (val1.bid,) = _struct_d.unpack(str[start:end])
        self.auction.available_clusters.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.topic
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.dst_robot
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3B.pack(_x.auction.auction_status_message, _x.auction.start_auction, _x.auction.auction_finished))
      length = len(self.auction.occupied_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.auction.occupied_ids:
        buff.write(_struct_q.pack(val1.id))
        _x = val1.detected_by_robot_str
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.auction.requested_clusters)
      buff.write(_struct_I.pack(length))
      for val1 in self.auction.requested_clusters:
        length = len(val1.ids_contained)
        buff.write(_struct_I.pack(length))
        for val2 in val1.ids_contained:
          buff.write(_struct_q.pack(val2.id))
          _x = val2.detected_by_robot_str
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.bid))
      buff.write(_struct_I.pack(self.auction.auction_id))
      _x = self.auction.robot_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.auction.available_clusters)
      buff.write(_struct_I.pack(length))
      for val1 in self.auction.available_clusters:
        length = len(val1.ids_contained)
        buff.write(_struct_I.pack(length))
        for val2 in val1.ids_contained:
          buff.write(_struct_q.pack(val2.id))
          _x = val2.detected_by_robot_str
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          if python3:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.bid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.auction is None:
        self.auction = adhoc_communication.msg.ExpAuction()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.topic = str[start:end].decode('utf-8')
      else:
        self.topic = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dst_robot = str[start:end].decode('utf-8')
      else:
        self.dst_robot = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.auction.auction_status_message, _x.auction.start_auction, _x.auction.auction_finished,) = _struct_3B.unpack(str[start:end])
      self.auction.auction_status_message = bool(self.auction.auction_status_message)
      self.auction.start_auction = bool(self.auction.start_auction)
      self.auction.auction_finished = bool(self.auction.auction_finished)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.auction.occupied_ids = []
      for i in range(0, length):
        val1 = adhoc_communication.msg.ExpAuctionElement()
        start = end
        end += 8
        (val1.id,) = _struct_q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.detected_by_robot_str = str[start:end].decode('utf-8')
        else:
          val1.detected_by_robot_str = str[start:end]
        self.auction.occupied_ids.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.auction.requested_clusters = []
      for i in range(0, length):
        val1 = adhoc_communication.msg.ExpCluster()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.ids_contained = []
        for i in range(0, length):
          val2 = adhoc_communication.msg.ExpClusterElement()
          start = end
          end += 8
          (val2.id,) = _struct_q.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detected_by_robot_str = str[start:end].decode('utf-8')
          else:
            val2.detected_by_robot_str = str[start:end]
          val1.ids_contained.append(val2)
        start = end
        end += 8
        (val1.bid,) = _struct_d.unpack(str[start:end])
        self.auction.requested_clusters.append(val1)
      start = end
      end += 4
      (self.auction.auction_id,) = _struct_I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.auction.robot_name = str[start:end].decode('utf-8')
      else:
        self.auction.robot_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.auction.available_clusters = []
      for i in range(0, length):
        val1 = adhoc_communication.msg.ExpCluster()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.ids_contained = []
        for i in range(0, length):
          val2 = adhoc_communication.msg.ExpClusterElement()
          start = end
          end += 8
          (val2.id,) = _struct_q.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detected_by_robot_str = str[start:end].decode('utf-8')
          else:
            val2.detected_by_robot_str = str[start:end]
          val1.ids_contained.append(val2)
        start = end
        end += 8
        (val1.bid,) = _struct_d.unpack(str[start:end])
        self.auction.available_clusters.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_q = struct.Struct("<q")
_struct_3B = struct.Struct("<3B")
_struct_d = struct.Struct("<d")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from adhoc_communication/SendExpAuctionResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SendExpAuctionResponse(genpy.Message):
  _md5sum = "284aa12dd9e9e760802ac9f38036ea5e"
  _type = "adhoc_communication/SendExpAuctionResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint8 status

"""
  __slots__ = ['status']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SendExpAuctionResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.status is None:
        self.status = 0
    else:
      self.status = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_B.pack(self.status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.status,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_B.pack(self.status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.status,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
class SendExpAuction(object):
  _type          = 'adhoc_communication/SendExpAuction'
  _md5sum = 'ff9ea50dac4ae5fb2075cab78b2fc2b9'
  _request_class  = SendExpAuctionRequest
  _response_class = SendExpAuctionResponse
